package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrSpecialRule;
import com.docus.server.entity.segmentation.OcrUrlConfig;
import com.docus.server.infrastructure.dao.IOcrUrlConfigDao;
import com.docus.server.infrastructure.mapper.OcrUrlConfigMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * ocr路径配置表 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrUrlConfigDaoImpl extends BaseDaoImpl<OcrUrlConfigMapper, OcrUrlConfig> implements IOcrUrlConfigDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrUrlConfig findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrUrlConfig 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrUrlConfig ocrUrlConfig) {
        return super.save(ocrUrlConfig);
    }

    /**
     * 编辑
     *
     * @param ocrUrlConfig 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrUrlConfig ocrUrlConfig) {
        return super.updateById(ocrUrlConfig);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrUrlConfig> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrUrlConfig> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(OcrUrlConfig::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(OcrUrlConfig::getCreateTime, endTime);
        }

        Object version = searchDTO.getParams("version");
        query.eq(OcrUrlConfig::getVersion,version);

        //默认createTime倒序排序
        query.orderByDesc(OcrUrlConfig::getCreateTime);
        List<OcrUrlConfig> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrUrlConfig> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrUrlConfig::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrUrlConfig::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
